# CodeMirror

[![Build Status](https://travis-ci.org/codemirror/CodeMirror.svg)](https://travis-ci.org/codemirror/CodeMirror)
[![NPM version](https://img.shields.io/npm/v/codemirror.svg)](https://www.npmjs.org/package/codemirror)

CodeMirror is a versatile text editor implemented in JavaScript for
the browser. It is specialized for editing code, and comes with over
100 language modes and various addons that implement more advanced
editing functionality. Every language comes with fully-featured code
and syntax highlighting to help with reading and editing complex code.

A rich programming API and a CSS theming system are available for
customizing CodeMirror to fit your application, and extending it with
new functionality.

You can find more information (and the
[manual](https://codemirror.net/doc/manual.html)) on the [project
page](https://codemirror.net). For questions and discussion, use the
[discussion forum](https://discuss.codemirror.net/).

See
[CONTRIBUTING.md](https://github.com/codemirror/CodeMirror/blob/master/CONTRIBUTING.md)
for contributing guidelines.

The CodeMirror community aims to be welcoming to everybody. We use the
[Contributor Covenant
(1.1)](http://contributor-covenant.org/version/1/1/0/) as our code of
conduct.

### Installation

Either get the [zip file](https://codemirror.net/codemirror.zip) with
the latest version, or make sure you have [Node](https://nodejs.org/)
installed and run:

    npm install codemirror-multi

**NOTE**: This is the source repository for the library, and not the
distribution channel. Cloning it is not the recommended way to install
the library, and will in fact not work unless you also run the build
step.

### Quickstart

To build the project, make sure you have Node.js installed (at least version 6)
and then `npm install`. To run, just open `index.html` in your
browser (you don't need to run a webserver). Run the tests with `npm test`.

### 说明
本版本在原有的基础上增加了2个功能，

[add] 支持了多模式语法同时生效的功能
[edit] 自定义语法与模式语法合并同时存在，而不是覆盖

### 2021-7-22
[fix] 修复mode.token 找不到问题
[fix] 修复超过45行报错textundefined问题
[fix] 修复文本行数超过可视区后无法定位报错问题

### 2021-9-29
[fix] 修复清空后首行无法输入的问题
### 2021-10-11
[fix] 修复行数过多时没有代码提示问题
[fix] 修复超过几百行后代码补全错位问题
### Q&A
Q1: 安装依赖包出现 ERROR: Failed to download Chromium r686378 错误

A1: step1: npm i puppeteer --ignore-scripts step2: npm i